/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010- Facebook, Inc. (http://www.facebook.com)         |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/
#include <runtime/eval/ast/statement.h>

namespace HPHP {
namespace Eval {
///////////////////////////////////////////////////////////////////////////////

void Statement::byteCode(ByteCodeProgram &code) const {
  throw FatalErrorException(0,"Cannot compile %s:%d", m_loc.file, m_loc.line1);
}

void optimize(VariableEnvironment &env, StatementPtr &stmt) {
  if (!stmt) return;
  if (StatementPtr optStmt = stmt->optimize(env)) {
    stmt = optStmt;
  }
}

///////////////////////////////////////////////////////////////////////////////
}
}

