/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010- Facebook, Inc. (http://www.facebook.com)         |
   | Copyright (c) 1997-2010 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#ifndef __EXTPROFILE_MYSQL_H__
#define __EXTPROFILE_MYSQL_H__

// >>>>>> Generated by idl.php. Do NOT modify. <<<<<<

#include <runtime/ext/ext_mysql.h>

namespace HPHP {
///////////////////////////////////////////////////////////////////////////////

inline Variant x_mysql_connect(CStrRef server = null_string, CStrRef username = null_string, CStrRef password = null_string, bool new_link = false, int client_flags = 0, int connect_timeout_ms = -1, int query_timeout_ms = -1) {
  FUNCTION_INJECTION_BUILTIN(mysql_connect);
  return f_mysql_connect(server, username, password, new_link, client_flags, connect_timeout_ms, query_timeout_ms);
}

inline Variant x_mysql_pconnect(CStrRef server = null_string, CStrRef username = null_string, CStrRef password = null_string, int client_flags = 0, int connect_timeout_ms = -1, int query_timeout_ms = -1) {
  FUNCTION_INJECTION_BUILTIN(mysql_pconnect);
  return f_mysql_pconnect(server, username, password, client_flags, connect_timeout_ms, query_timeout_ms);
}

inline Variant x_mysql_connect_with_db(CStrRef server = null_string, CStrRef username = null_string, CStrRef password = null_string, CStrRef database = null_string, bool new_link = false, int client_flags = 0, int connect_timeout_ms = -1, int query_timeout_ms = -1) {
  FUNCTION_INJECTION_BUILTIN(mysql_connect_with_db);
  return f_mysql_connect_with_db(server, username, password, database, new_link, client_flags, connect_timeout_ms, query_timeout_ms);
}

inline Variant x_mysql_pconnect_with_db(CStrRef server = null_string, CStrRef username = null_string, CStrRef password = null_string, CStrRef database = null_string, int client_flags = 0, int connect_timeout_ms = -1, int query_timeout_ms = -1) {
  FUNCTION_INJECTION_BUILTIN(mysql_pconnect_with_db);
  return f_mysql_pconnect_with_db(server, username, password, database, client_flags, connect_timeout_ms, query_timeout_ms);
}

inline Variant x_mysql_set_charset(CStrRef charset, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_set_charset);
  return f_mysql_set_charset(charset, link_identifier);
}

inline Variant x_mysql_ping(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_ping);
  return f_mysql_ping(link_identifier);
}

inline String x_mysql_escape_string(CStrRef unescaped_string) {
  FUNCTION_INJECTION_BUILTIN(mysql_escape_string);
  TAINT_OBSERVER(TAINT_BIT_MUTATED, TAINT_BIT_SQL);
  return f_mysql_escape_string(unescaped_string);
}

inline Variant x_mysql_real_escape_string(CStrRef unescaped_string, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_real_escape_string);
  TAINT_OBSERVER(TAINT_BIT_MUTATED, TAINT_BIT_SQL);
  return f_mysql_real_escape_string(unescaped_string, link_identifier);
}

inline Variant x_mysql_client_encoding(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_client_encoding);
  return f_mysql_client_encoding(link_identifier);
}

inline Variant x_mysql_close(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_close);
  return f_mysql_close(link_identifier);
}

inline Variant x_mysql_errno(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_errno);
  return f_mysql_errno(link_identifier);
}

inline Variant x_mysql_error(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_error);
  return f_mysql_error(link_identifier);
}

inline String x_mysql_get_client_info() {
  FUNCTION_INJECTION_BUILTIN(mysql_get_client_info);
  return f_mysql_get_client_info();
}

inline Variant x_mysql_get_host_info(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_get_host_info);
  return f_mysql_get_host_info(link_identifier);
}

inline Variant x_mysql_get_proto_info(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_get_proto_info);
  return f_mysql_get_proto_info(link_identifier);
}

inline Variant x_mysql_get_server_info(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_get_server_info);
  return f_mysql_get_server_info(link_identifier);
}

inline Variant x_mysql_info(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_info);
  TAINT_OBSERVER(TAINT_BIT_MUTATED, TAINT_BIT_NONE);
  return f_mysql_info(link_identifier);
}

inline Variant x_mysql_insert_id(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_insert_id);
  return f_mysql_insert_id(link_identifier);
}

inline Variant x_mysql_stat(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_stat);
  TAINT_OBSERVER(TAINT_BIT_MUTATED, TAINT_BIT_NONE);
  return f_mysql_stat(link_identifier);
}

inline Variant x_mysql_thread_id(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_thread_id);
  return f_mysql_thread_id(link_identifier);
}

inline Variant x_mysql_create_db(CStrRef db, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_create_db);
  return f_mysql_create_db(db, link_identifier);
}

inline Variant x_mysql_select_db(CStrRef db, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_select_db);
  return f_mysql_select_db(db, link_identifier);
}

inline Variant x_mysql_drop_db(CStrRef db, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_drop_db);
  return f_mysql_drop_db(db, link_identifier);
}

inline Variant x_mysql_affected_rows(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_affected_rows);
  return f_mysql_affected_rows(link_identifier);
}

inline bool x_mysql_set_timeout(int query_timeout_ms = -1, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_set_timeout);
  return f_mysql_set_timeout(query_timeout_ms, link_identifier);
}

inline Variant x_mysql_query(CStrRef query, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_query);
  return f_mysql_query(query, link_identifier);
}

inline Variant x_mysql_multi_query(CStrRef query, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_multi_query);
  return f_mysql_multi_query(query, link_identifier);
}

inline bool x_mysql_next_result(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_next_result);
  return f_mysql_next_result(link_identifier);
}

inline bool x_mysql_more_results(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_more_results);
  return f_mysql_more_results(link_identifier);
}

inline Variant x_mysql_fetch_result(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_result);
  return f_mysql_fetch_result(link_identifier);
}

inline Variant x_mysql_unbuffered_query(CStrRef query, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_unbuffered_query);
  return f_mysql_unbuffered_query(query, link_identifier);
}

inline Variant x_mysql_db_query(CStrRef database, CStrRef query, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_db_query);
  return f_mysql_db_query(database, query, link_identifier);
}

inline Variant x_mysql_list_dbs(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_list_dbs);
  return f_mysql_list_dbs(link_identifier);
}

inline Variant x_mysql_list_tables(CStrRef database, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_list_tables);
  return f_mysql_list_tables(database, link_identifier);
}

inline Variant x_mysql_list_fields(CStrRef database_name, CStrRef table_name, CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_list_fields);
  return f_mysql_list_fields(database_name, table_name, link_identifier);
}

inline Variant x_mysql_list_processes(CVarRef link_identifier = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_list_processes);
  return f_mysql_list_processes(link_identifier);
}

inline Variant x_mysql_db_name(CVarRef result, int row, CVarRef field = null_variant) {
  FUNCTION_INJECTION_BUILTIN(mysql_db_name);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_db_name(result, row, field);
}

inline Variant x_mysql_tablename(CVarRef result, int i) {
  FUNCTION_INJECTION_BUILTIN(mysql_tablename);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_tablename(result, i);
}

inline Variant x_mysql_num_fields(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_num_fields);
  return f_mysql_num_fields(result);
}

inline Variant x_mysql_num_rows(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_num_rows);
  return f_mysql_num_rows(result);
}

inline Variant x_mysql_free_result(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_free_result);
  return f_mysql_free_result(result);
}

inline bool x_mysql_data_seek(CVarRef result, int row) {
  FUNCTION_INJECTION_BUILTIN(mysql_data_seek);
  return f_mysql_data_seek(result, row);
}

inline Variant x_mysql_fetch_row(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_row);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_fetch_row(result);
}

inline Variant x_mysql_fetch_assoc(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_assoc);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_fetch_assoc(result);
}

inline Variant x_mysql_fetch_array(CVarRef result, int result_type = 3) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_array);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_fetch_array(result, result_type);
}

inline Variant x_mysql_fetch_lengths(CVarRef result) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_lengths);
  return f_mysql_fetch_lengths(result);
}

inline Variant x_mysql_fetch_object(CVarRef result, CStrRef class_name = "stdClass", CArrRef params = null) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_object);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_fetch_object(result, class_name, params);
}

inline Variant x_mysql_result(CVarRef result, int row, CVarRef field = null_variant) {
  FUNCTION_INJECTION_BUILTIN(mysql_result);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_result(result, row, field);
}

inline Variant x_mysql_fetch_field(CVarRef result, int field = -1) {
  FUNCTION_INJECTION_BUILTIN(mysql_fetch_field);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_fetch_field(result, field);
}

inline bool x_mysql_field_seek(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_seek);
  return f_mysql_field_seek(result, field);
}

inline Variant x_mysql_field_name(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_name);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_field_name(result, field);
}

inline Variant x_mysql_field_table(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_table);
  TAINT_OBSERVER(TAINT_BIT_ALL, TAINT_BIT_NONE);
  return f_mysql_field_table(result, field);
}

inline Variant x_mysql_field_len(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_len);
  return f_mysql_field_len(result, field);
}

inline Variant x_mysql_field_type(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_type);
  return f_mysql_field_type(result, field);
}

inline Variant x_mysql_field_flags(CVarRef result, int field = 0) {
  FUNCTION_INJECTION_BUILTIN(mysql_field_flags);
  return f_mysql_field_flags(result, field);
}


///////////////////////////////////////////////////////////////////////////////
}

#endif // __EXTPROFILE_MYSQL_H__
